# components

## basic building blocks: can use iced widgets for now

- button
- search box (1 line)
- bubble selections/tab bar (for filters)
- pop-up menu
- text input box
- pop-up/overlay
- selectable
- switches
- tooltip (for when hover over icon and need description text)
- dialog
- image
- slider
- checkbox
- radio
- image
- menu bar

## components

- log in menu (for first time connection)
- error toast
- user info, click for menu to set status, switch accounts
- profile icon (3 styles: user, guild, group)
- contact list
- contact list item
- pinnable shortcuts bar
- chats list (configurable: what's included, ordering, filtering, preview length)
  - dms
  - groups
  - guilds
- chats list item
- message view
- user list (for group chats, channels)
- scrollable menu
- separated navigation bar (to put in contacts, guilds, spaces)
- settings page (not very customizable)
  - profile settings/customisation
  - keymap settings
  - privacy settings
- contact pop-up
- contact profile
- dm info/settings
- group chat info/settings
- keyboard hints
- notification inbox (for pings/mentions, pending messages)
- pop-in sidebar
- debug console window (for showing logs, and both showing incoming raw xmpp stanzas and sending raw xmpp stanzas)
- service discovery
- command execution

## temporary

- message

## later

- video widget
- animated images
- 3d model viewer (lol why not)
- everything to do with voice and video
- reactions
- stuff to do with gifs, voice messages, etc.

